; drv16F887\EEPROM.asm
; 2008-02-25 : nouvelle mouture : lit avant d'crire, a simplifie l'applicatif
; version 2008-04-27

; fonction "short"
S__EEPROM_READ ; appeler dans bank0 par dfaut
; adresse de l'octet  lire : dans W
; valeur de retour dans W
	bsf		STATUS, RP1		; bank2
		movwf	EEADR & 127		; set address
		bsf		STATUS, RP0		; bank3
			bcf		EECON1 & 127, EEPGD	; address data EEPROM
			bsf		EECON1 & 127, RD	; trigger reading
		bcf		STATUS, RP0		; bank2
		movf	EEDATA & 127, W	; data read
	bcf		STATUS, RP1		; bank0
	return

; voir aussi la macro READEEPROM dans EEPROM.inc

; fonction "short"
S__EEPROM_write
; adresse dans W, data dans tmp_leaf1

; disable IRQs ?

; A) lecture de la donne
	bsf		STATUS, RP1		; bank2
		movwf	EEADR & 127		; set address
		bsf		STATUS, RP0		; bank3
			bcf		EECON1 & 127, EEPGD	; address data EEPROM
			bsf		EECON1 & 127, RD	; trigger reading
		bcf		STATUS, RP0		; bank2
		movf	EEDATA & 127, W	; data read
; compare avec la nouvelle valeur
		xorwf	tmp_leaf1,w
		btfsc	STATUS,Z
		goto	EEPROM_end_write	

; B) criture effective
		movfw	tmp_leaf1
		movwf	EEDATA & 127
		bsf		STATUS, RP0		; bank3
			bcf		EECON1 & 127, EEPGD	; address data EEPROM
			bsf		EECON1 & 127, WREN	; set WREN
			movlw	0x55
			movwf	EECON2 & 127	; set EECON2 to 55h
			movlw	0xAA
			movwf	EECON2 & 127	; set EECON2 to AAh
			bsf		EECON1 & 127, WR; trigger writing
			; enable IRQs ?
			; poll for completion
loop_wait_EEPROM
			; clrwdt
			; do something more useful here ?
			; yield, timeout ???
			btfsc	EECON1 & 127, WR
			goto	loop_wait_EEPROM
			bcf		EECON1 & 127, WREN	; disable writes
		bcf		STATUS, RP0		; retour de bank3 vers bank2
EEPROM_end_write
	bcf		STATUS, RP1	; de bank2 vers bank 0
	; IRQ ?
	return	
