; drv16F887\PIC16F887.asm
; version PCBv2 20080411
; inclus directement pour que le code de l'ISR soit  la bonne adresse

; startup : recopi de f887temp.asm fourni par microchip
	ORG		0x000			; processor reset vector
	nop						; nop required for icd !
	goto	init_887		; go to beginning of program

	ORG		0x004			; interrupt vector location

; les IRQ ne sont pas traites pour l'instant.

;;	movwf	w_temp			; save off current W register contents
;;	movf	STATUS,w		; move status register into W register
;;	movwf	status_temp		; save off contents of STATUS register
;;	movf	PCLATH,w		; move pclath register into w register
;;	movwf	pclath_temp		; save off contents of PCLATH register
;;
;;	clrf	STATUS
;;
;;; la source de l'IRQ est traite ici.
;;; faire attention  la profondeur de la pile,
;;; surtout  cause de l'ICD2, donc viter les call autant que possible
;;
;;; Lire INTCON et dtecter :
;;;  INT -> PowerFailure
;;;  FailSafe Clock Monitor
;;
;;; Powerfail :
;;;	btfss	INTCON,INTF
;;;	goto	pas_int
;;; * dsactiver I/O (backlight, NRI_INH, etc)
;;; * sauver tous les paramtres
;;; * ractiver backlight ? provoquer brownout
;;; * boucler tant que RB0  0 puis goto init_887 ?
;;
;;; en cas de perte de quartz :
;;;  dclencher IRQ, mettre INTOSC 8MHz, afficher message erreur, bloquer
;;; " Quartz failure "
;;
;;;pas_int
;;	movf	pclath_temp,w	; retrieve copy of PCLATH register
;;	movwf	PCLATH			; restore pre-isr PCLATH register contents
;;	movf	status_temp,w	; retrieve copy of STATUS register
;;	movwf	STATUS			; restore pre-isr STATUS register contents
;;	swapf	w_temp,f
;;	swapf	w_temp,w		; restore pre-isr W register contents
;;	retfie					; return from interrupt
;;
;;
; init gnrale des ports du 16F877A
init_887
	clrf	STATUS
	clrf	PORTD

	movlw	1<<Bit_backlight; backlight actif, et PWM, NRI_inhibit et relais dsactivs au dmarrage
	movwf	PORTC

	bsf STATUS, RP0	; (bank1)

		bsf STATUS, RP1	; (bank3)
			clrf	ANSEL  & 127 ; init des ports A et B
			clrf	ANSELH & 127 ; en digital seulement
		bcf STATUS, RP1

		movlw	0xFF
		movwf	PORTA ; tous les ports en entre

		movwf	PORTB ; entre aussi
;		movwf	WPUB ; pull-up actif partout

		; Relais, PWM, NRI_inhibit et backlight en sortie : /!\RS232
		movlw	~((1<<Bit_NRI_Inhibit)|(1<<Bit_relais)|(1<<Bit_Contrast)|(1<<Bit_backlight))
		movwf	PORTC

; vrifier la sortie de RC6 pour l'envoi RS232 !!!! |(1<<Bit_RS232_TX)
		clrf	PORTD	; tous les bits en sortie (mme RD3 inutilis)

		movlw	0x07 ; dsactive le PSP, PORTE en entre (optos avec pull-ups)
		movwf	PORTE

; init du Timer, des pull-ups etc.
; RBPU = 0 (Pull-ups activs)
; INTEDG = 0 (INT quand tension descend)
; T0CS = 0 (horloge interne)
; T0SE = 0 (pas important)
; PSA = 0 (Prescaler pour TMR0)
; PS2:PS0 = 011 (CLK/4*16 => overflow  1125Hz)
		movlw	3
		movwf	OPTION_REG & 127

		movlw	128 ; priode PWM (voir le calcul plus bas)
		movwf	PR2 & 127

; configuration de IRCF<2:0> dans OSCCON : INTOSC 8MHz (en cas de perte du quartz)
		movlw	7<<4
		iorwf	OSCCON & 127,f

	bcf		STATUS, RP0 ; retour en banque 0

; configure la PWM pour initialiser immdiatement le contraste
	READEEPROM	EEPROM_contrast, CCPR1L ; lecture de la valeur du contraste dans l'EEPROM
	movlw	(1<<TMR2ON) ; Timer2 allum, mais pas de postscale ni de prescale
	movwf	T2CON

; initialise CCP1:
; P1M : single output,
; LSB du PWM  0
; mode PWM
	movlw	0xC
	movwf	CCP1CON
; frquence mesure sur RC2 : 18KHz exactement pour PR2=255
; on peut pas faire plus rapide pour rduire le condo ?
; --> rduire PR2  64
; --> mettre les LSB du contraste dans CCP1CON
; mais SW plus complexe donc :
;  PR2 rduit  128 ==> condo = 5uF et frquence = 36KHz


; dtecter aussi :
; * WDT  --> STATUS[TO]  0
; * EEPROM pas fini d'crire
; * oscillateur HS

;	goto	main		; fold par inclusion
