; drv16F887\LCD.inc

	cblock
		string_high, string_low, cursor_index
		convert_byte, leading0, LCD_delay
	endc

LOAD_STRING_PTR	macro address
	; affiche le message
	movlw	address >> 8
	movwf	string_high
	movlw	address & 255
	movwf	string_low
	endm


#define LCD_WRITE			(0)
#define LCD_READ			(1<<Bit_LCD_RW)

#define LCD_RS_INSTR		(0)
#define LCD_RS_DATA			(1<<Bit_LCD_RS)

#define LCD_Instr_ClearDisplay		(1)
#define LCD_Instr_ReturnHome    	(1<<1)
#define LCD_Instr_EntryModeSet		(1<<2) ; utilise LCD_ID_* et LCD_S_*
#define LCD_Instr_DisplayControl	(1<<3) ; utilise LCD_D_* , LCD_C_* et LCD_B_*
#define LCD_Instr_CursorShift		(1<<4) ; utilise LCD_SC_* et LCD_RL_*
#define LCD_Instr_FunctionSet		(1<<5) ; donn en constantes  l'initialisation
#define LCD_Instr_CGRAMaddr			(1<<6) ; accompagne une valeur < 64
#define LCD_Instr_DDRAMaddr			(1<<7) ; accompagne une valeur < 128

; LCD_Instr_EntryModeSet :

#define LCD_ID_Increment	(0)		; incrmente ou dcrmente
#define LCD_ID_Decrement	(1<<1)	; lorsque DDRAM/CGRAM est crit

#define LCD_S_Shift			(1<<0) ; "accompanies display shift"

; LCD_Instr_DisplayControl :

#define LCD_D_DisplayOff	(0)
#define LCD_D_DisplayOn		(1<<2)

#define LCD_C_CursorOff		(0)
#define LCD_C_CursorOn		(1<<1)

#define LCD_B_CursorBlock	(0)
#define LCD_B_CursorBlink	(1<<0)

; LCD_Instr_CursorShift :

#define LCD_SC_CursorMove   (0) ; bouge le curseur
#define LCD_SC_DisplayShift (1) ; dcale l'cran  l'criture 

#define LCD_RL_Left			(0) ; shift to the left
#define LCD_RL_Right		(1<<2) ; shift to the right

; LCD_Instr_FunctionSet :

#define LCD_DL_8bits		(0) ;
#define LCD_DL_4bits		(1<<4) ; largeur de l'interface

; configuration actuelle :
#define LCD_FORMAT			(0<<2) ; 0 => 5x8 pixels, 1 => 5x10 pixels
#define LCD_NB_LINES		(1<<3) ; 0 => 1 ligne,    1 => 2 lignes (marchpa)
	; l'arnaaaaque ! faut mettre le LCD16x1 en mode 2 lignes pour pouvoir utiliser
	; les 2 moitis de l'affichage, et on s'en rend pas compte car le contraste
	; change en fonction du nb de lignes configur dans le contrleur LCD
