; drv16F887\io.inc

; /!\ version PCB V3, avec des broches ralloues

; gre les entres/sorties de la puce
; j'ai tout centralis ici car a faisait trop de fichiers disparates
; et chiants  mettre  jour...

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; PortA : 6 bits en entre, pour lire les impulsions du NRI
#define Port_NRI_DATA	PORTA

MACRO_activate_NRI_port	macro
	bsf STATUS, RP0	; (bank1)
		movwf	Port_NRI_DATA	; TRISA
	bcf STATUS, RP0	; (bank0)
	endm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; PortB : boutons (car pull-up dispos sur RBx)
; weak pull-up mis dans OPTION et WPUB par drv16F877A\PIC16F877A.asm

; RB0 INT -> power failure
; RB1 bouton gauche
; RB2 bouton milieu
; RB3 maintenance, PGM (garder  zro/gnd pour la premire programmation)
; RB4 bouton droite
; RB5 cl menu
; RB6 PGC \
; RB7 PGD / ICD

#define Port_kbd			PORTB
#define Bit_kbd_PowerFail	0
#define Bit_kbd_Left		1
#define Bit_kbd_Middle		2
#define Bit_kbd_PGM			3
#define Bit_kbd_Right		4
#define Bit_kbd_Lock		5

#define KBD_PowerFail	Port_kbd, Bit_kbd_PowerFail
#define KBD_Left		Port_kbd, Bit_kbd_Left
#define KBD_Middle		Port_kbd, Bit_kbd_Middle
#define KBD_PGM			Port_kbd, Bit_kbd_PGM
#define KBD_Right		Port_kbd, Bit_kbd_Right
#define KBD_Lock		Port_kbd, Bit_kbd_Lock


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Port C : surtout des sorties

; RC0 : inhibit du NRI (mettre  1 pour accepter les pices)
; il y a un pull-up entre +12V du NRI et la broche INHIBIT,
; un MOSFET l'amne  la masse quand on alimente sa grille.
; au boot, le PIC est HiZ, donc MOSFET non passant,
; donc INHIBIT est actif (pas de pice accepte).
#define Bit_NRI_Inhibit 0
#define Port_NRI_CTL	PORTC
#define	INHIBIT_PORT	Port_NRI_CTL, Bit_NRI_Inhibit
MACRO_NRI_INHIBIT macro ; empche les pices de passer
	bcf INHIBIT_PORT
	endm
MACRO_NRI_ACCEPT macro  ; accepte les pices.
	bsf INHIBIT_PORT
	endm

; RC1 : sortie relais
#define Bit_relais  1
#define Port_relais	PORTC
#define relais		Port_relais, Bit_relais
MACRO_RELAIS_FERME	macro
	bsf relais
	endm
MACRO_RELAIS_OUVRE	macro
	bcf relais
	endm

; RC2 : PWM/CCP1 output
#define	Bit_Contrast	2

; RC3    (rserv I2C-SCL, pull-up 5K absent)
; RC4    (rserv I2C SDA, pull-up 5K absent)
; RC5    : optorelais #2
; RC6 RS232 TX
; RC7 RS232 RX
#define Bit_RS232_TX	6
#define Bit_RS232_RX	7


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;PortD : LCD
;RD0 E
;RD1 RS
;RD2 RW
;RD3 backlight ON/OFF
#define Bit_backlight	3
#define Port_backlight	PORTD
#define backlight		Port_backlight, Bit_backlight
MACRO_BACKLIGHT_ON macro
	bsf backlight
	endm
MACRO_BACKLIGHT_OFF macro
	bcf backlight
	endm

;RD4 LCD_D4
;RD5 LCD_D5
;RD6 LCD_D6
;RD7 LCD_D7

#define Port_LCD	PORTD
#define Bit_LCD_E	0
#define Bit_LCD_RS	1
#define Bit_LCD_RW	2

#define LCD_E  Port_LCD, Bit_LCD_E
#define LCD_RS Port_LCD, Bit_LCD_RS
#define LCD_RW Port_LCD, Bit_LCD_RW


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; PortE : entres
; RE0 OPTO Pulse
; RE1 OPTO Format
; RE2 OPTO Color

#define Port_opto	PORTE
#define Bit_opto_Pulse	0
#define Bit_opto_Format	1
#define Bit_opto_Color	2

#define OPTO_PULSE  Port_opto, Bit_opto_Pulse
#define OPTO_FORMAT Port_opto, Bit_opto_Format
#define OPTO_COLOR  Port_opto, Bit_opto_Color



