;  main.asm
;
;  version 2008-04-27 / yg
;
; c'est le fichier qui incorpore tous les autres.
; L'ordre d'inclusion des fichiers est critique !

	expand	; facilite normment le travail avec les macros
	RADIX		DEC

	#include "version.inc" ; dtermine le type de PCB, la langue...

    #include "drv16F887\PIC16F887.inc" ; dclarations du modle du PIC
    #include "drv16F887\math.inc" ; pour faire les calculs sur 24 bits

; inclusion des autres fichiers de dclaration des priphriques :
    #include "drv16F887\delay.inc"
    #include "iodrv\io.inc"
    #include "iodrv\LCD.inc"
	#include "iodrv\serial.inc"
	#include "drv16F887\EEPROM.inc" ; dclare aussi le contenu (initial) de l'EEPROM

; inclusion des dfinitions du MTK, paramtres pour ce projet
    #include "mtk\mtk.inc"


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Dclaration des threads
; Dfinition des champs dans l'ordre :
; * nom  donner au label (data) pour le dbut du buffer de contexte
; * adresse du dbut du code du thread
; * Etat initial du thread
; * Paramtre initial (dpend de l'tat, par exemple dure de temporisation ou adresse de poll)
; * Nom  donner au label (data) de la base de la pile
; * profondeur de la pile (en appels)
; (voir aussi MACRO_init_thread dans mtk\dispatch.inc)

; c'est le thread qui fait presque tout le boulot, il faut une bonne profondeur de pile :
#define __MTKTHREADS1	thread_init_base, L3__thread_init_start, THREAD_RUNNING, 0, thread_init_stack, 9

; ce thread a juste besoin d'appels systmes, donc pile minimale :
#define __MTKTHREADS2	thread_nri_base, thread_nri_start, THREAD_RUNNING, 0, thread_nri_stack, 2

; thread qui indique qu'une copie a t dclenche
#define __MTKTHREADS3   thread_copy_base, thread_copy_start, THREAD_ASLEEP, 0, thread_copy_stack, 2

; insrer ici les autres threads :
;#define __MTKTHREADS4	
;#define __MTKTHREADS5
;#define __MTKTHREADS6

; S'il y a besoin de plus que 10 threads, mettre  jour mtk.asm. Il n'y a pas vraiment
; de limite, mais a dpend de la place disponible dans le PIC et des dfinitions dans mtk.inc.
; Par contre, plus il y a de threads, plus la capacit temps rel est difficile  maintenir.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; inclusion des dclarations des threads
	#include "threads\thread_init.inc"
	#include "threads\thread_nri.inc"
	#include "threads\thread_copy.inc"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;; le code excutable commence ici ;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; code de dmarrage, d'init des ports et stub d'ISR
	#include "drv16F887\PIC16F887.asm"

; On embraye tout de suite dans l'initialisation
; des threads, leur dclaration puis le dispatcheur :
    #include "mtk/mtk.asm"

; La suite n'est qu'une collection de fonctions.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Inclusion des autres fichiers pour la gestion des priphriques :
; (les fichiers contenant des "computed GOTO" doivent
; viter les pb de changements de pages)

; attention : en raison de l'utilisation des Macro_CALL et Macro_RETURN,
; l'ordre d'inclusion est important, sinon l'assembleur pte une durite.
; En fait, sa capacit  rsoudre des symboles encore inexistants est limite.
; Les fonctions "leaf" doivent donc tre dclares d'abord, et les fonctions
; appelantes ensuite.

    #include "drv16F887\delay.asm"
;	#include "iodrv\serial.asm"
	#include "drv16F887\EEPROM.asm"
	#include "iodrv\LCD.asm"
    #include "menu\menu_functions.asm" ; qqs fonctions de plus haut niveau
         ; qui utilisent les fonctions dans LCD.asm, et donc  mettre aprs)

; inclusion des threads
	#include "threads\thread_init.asm" ; thread principal
		; qui inclut aussi les fichiers des pages du menu
	#include "threads\thread_nri.asm"
	#include "threads\thread_copy.asm"

; zone de constantes (pointeurs "longs")
    #include "messages\fontes.asm" ; l'ordre de ces 2 fichiers peut tre chang
    #include "messages\messages.asm" ; si la compilation envoie des erreurs

	END
