; menu\menu_coin_value.asm
; version 20080430

	clrf	autorepeat
	goto	LS__MENU__coin_value

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Fonction qui prend en paramtre un numro de canal (menu_coin_index)
; et ajuste la valeur de la pice correspondante.
;
; C'est appel par le sous-menus manuel avec
; comme paramtre menu_coin_index (de 0  5)
;
; Le menu "auto" saute en plein milieu car il faut
; dj dterminer le n du canal. Sauter dedans vite
; de recopier/dupliquer le code, mais ajoute qqs bizarreries
; dans le code pour viter certaines conditions interdites
; (par exemple, viter de sauver les paramtres pour un canal
; inexistant, le n8 a t prvu pour dtecter a).

LS__MENU_coin_channel
; cran remis  zro avant appel

; affiche le message
	LOAD_STRING_PTR	string_menu_channel
	Macro_CALL	L1S2__display_string, 0
; affiche l'index (n du canal)
	movfw	menu_coin_index
	addlw	'1'
	movwf	tmp_leaf1
	Macro_CALL	LS2__LCD_display_char, 1

; lecture de la valeur en EEPROM
	movfw	menu_coin_index
	addlw	EE_CHAN1val & 255
	call	S__EEPROM_READ
	movwf	chan_value

; scinde la valeur en exposant et mantisse
	; exposant
	andlw	7 ; l'index est infrieur  6
	addlw	1 ; off-by-one dans la boucle d'affichage
	movwf	coin_val_pos
	; ajuste l'exposant si le signe de monnaie n'est pas affich (en position 16)
	btfsc	currency_shift,4
	incf	coin_val_pos,f
	; mantisse :
	swapf	chan_value,w
	andlw	7 ; la valeur de la pice est infrieure ou gale  5
	movwf	coin_val_digit

MENU__coin_chan_key_loop

; place le curseur au dbut du nombre
	movlw	9
    ; si pas de signe (en position linaire 16), remplir avec un espace
	btfsc	currency_shift,4
	addlw	1
	movwf	tmp_leaf1
	Macro_CALL	LS1__set_DDRAM_address_linear, 0

; dtecter si canal OFF
	movf	coin_val_digit,f
	btfss	STATUS,Z
	goto	display_coin_value

; affiche "OFF"
		LOAD_STRING_PTR	string_OFF
		Macro_CALL	L1S2__display_string, 1
		goto	fin_display_off ; pas de fold car goto forward

; si pas OFF, affiche la valeur (copie modifie de menu_position.asm)

; remplacer par L1_DisplayPrice ??

display_coin_value
	clrf	leading0 ; n'affiche pas encore de 0
; boucle 6 fois
	movlw	6
	movwf	char_cpt
loop_nb_coin

	; SI l'exposant du chiffre == coin_val_pos
	; alors afficher le chiffre, sinon 0/' '
		movfw	char_cpt
		xorwf	coin_val_pos,w
		btfsc	STATUS,Z
		goto	display_coin_digit ; goto si char_cpt == coin_val_pos

		; affiche un espace si pas encore de caractres
		movlw	' '
		btfsc	leading0,0
			movlw	'0'
			goto	write_tmp_leaf1

		; afficher le chiffre
display_coin_digit
			bsf		leading0,0 ; afficher les prochains zros
			movfw	coin_val_digit
			addlw	'0'
write_tmp_leaf1
		movwf	tmp_leaf1
		Macro_CALL	LS2__LCD_display_char, 0

	; SI la position courante == tmp_currency_shift
		movfw	cursor_index
		xorwf	currency_shift,w
		btfss	STATUS,Z
		goto	menu_coin_fin_loop

	; ALORS afficher le "signe"
			bsf		leading0,0 ; afficher les prochains zros
			movfw	currency_sign
			movwf	tmp_leaf1
			Macro_CALL	LS2__LCD_display_char, 1
menu_coin_fin_loop

	; arrte la boucle
	decfsz	char_cpt,f
	goto	loop_nb_coin

fin_display_off

; Point d'entre pour la dtection automatique :

; attendre que les 3 boutons soient relachs ( 1)
L__MENU__coin_kbd1
	movlw	30
	Macro_DELAY 0
	movfw	Port_kbd
	andlw	(1<<Bit_kbd_Left) | (1<<Bit_kbd_Middle) | (1<<Bit_kbd_Right)
	xorlw	(1<<Bit_kbd_Left) | (1<<Bit_kbd_Middle) | (1<<Bit_kbd_Right)
	btfss	STATUS,Z
	goto	L__MENU__coin_kbd1

; attendre qu'un des boutons soit appuy ou qu'une pice soit arrive
MENU__coin_kbd2
	movlw	30
	Macro_DELAY 0

; est-ce une pice ?
	btfss	thread_nri_accept,2
	goto	MENU__coin_testRight

; Sauve la dure de l'impulsion dans l'EEPROM
		movfw	thread_nri_pulse_length
		movwf	tmp_leaf1
		movlw	EE_NRI_pulse_length_nom & 255
		call	S__EEPROM_write

		goto	MENU__coin_end ; ACK dans la boucle de MENU__coin_auto_loop

MENU__coin_testRight
	btfsc	menu_coin_index,3 ; index>=8 ? (dsactivation des boutons droite/gauche)
	goto	MENU__coin_testCenter


; est-ce le bouton droit ?
	btfsc	KBD_Right
	goto	MENU__coin_testLeft

; incrmentation du chiffre
		bcf		STATUS,C ; vide le carry pour ne pas l'injecter dans la rotation
		; sauf si il faut ajuster 4->5 (en fait : 2->5)
		btfsc	coin_val_digit,1
		bsf		STATUS,C
		; ou si coin_val_digit==0 (OFF)
		movf	coin_val_digit,f
		btfsc	STATUS,Z
		bsf		STATUS,C
		; dcalage  gauche
		rlf		coin_val_digit,f ; valeurs : 1->2->5->10

		btfss	coin_val_digit,3 ; est-ce qu'on a atteint 10 ?
		goto	MENU__coin_chan_key_loop ; retour

		movlw	5 ;recharge spculativement la valeur de la pice
		movwf	coin_val_digit
		; si l'index n'est pas dj  5 alors on peut incrmenter
		movlw	5
		xorwf	coin_val_pos,w
		btfsc	STATUS,Z
		goto	MENU__coin_chan_key_loop ; retour

		;recharge la valeur de la pice
		movlw	1
		movwf	coin_val_digit
		incf	coin_val_pos,f
		goto	MENU__coin_chan_key_loop ; retour


; est-ce le bouton gauche ?
MENU__coin_testLeft
	btfsc	KBD_Left
	goto	MENU__coin_testCenter

; dcrmentation du chiffre
		bcf		STATUS,C ; vide le carry pour ne pas l'injecter dans la rotation
		rrf		coin_val_digit,f ; valeurs : 5->2->1->Z
		movfw	coin_val_digit ; connerie de rrf qui met pas Z  jour !!
		btfss	STATUS,Z
		goto	MENU__coin_chan_key_loop ; retour

		clrf	coin_val_digit ; vide spculativement la pice pour afficher "OFF"
		; si l'index n'est pas dj  1 alors on peut dcrmenter
		movlw	1
		xorwf	coin_val_pos,w
		btfsc	STATUS,Z
		goto	MENU__coin_chan_key_loop ; retour

		; dcrmente la position de la pice
		decf	coin_val_pos,f
		movlw	5 ;recharge 5 dans la valeur de la pice
		movwf	coin_val_digit
		goto	MENU__coin_chan_key_loop ; retour


; Si c'est le bouton du milieu ou une pice, alors on sort de la boucle
MENU__coin_testCenter
	btfsc	KBD_Middle
	goto	MENU__coin_kbd2 ; reboucle si on a rat une impulsion trop courte

MENU__coin_end
	btfsc	menu_coin_index,3 ; index>=8 ? (dsactivation des sauvegardes)
	goto	cetaitunepiece

; modifie le masque d'activation NRI :
; calcule le nouveau masque en appelant la table des exp2 du MTK
; attention  PCLATH, a risque de foirer au retour
	if (exp2table_noswap >> 8) == 0
		clrf	PCLATH
	else
		movlw	exp2table_noswap >> 8
		movwf	PCLATH
		error	"menu_coin_value.asm: PCLATH pas encore test"
	endif
	movfw	menu_coin_index
	call	exp2table_noswap
;	OR (activation) spculatif
	iorwf	thread_nri_mask,f
	movf	coin_val_digit,f
; est-ce qu'il y a un digit, ou c'est OFF ?
	btfss	STATUS,Z
	goto	activate_coin
; si chiffre==OFF alors efface le bit (dsactive le canal)
	xorwf	thread_nri_mask,f ; on sait qu'il est dj  1, donc XOR met  0
	;clrf	un_truc....
activate_coin
	movfw	thread_nri_mask
	MACRO_activate_NRI_port ; met TRISA  jour
; sauve le mask en EEPROM :
	movwf	tmp_leaf1	; thread_nri_mask reste dans W aprs la macro
	movlw	EE_CHAN_EN & 255
	call	S__EEPROM_write

; reconstruit la valeur de pice pour l'EEPROM
	decf	coin_val_pos,f ; off-by-one dans la boucle d'affichage
	; ajuste l'exposant si le signe de monnaie n'est pas affich (en position 16)
	btfsc	currency_shift,4
	decf	coin_val_pos,f
	swapf	coin_val_digit,w
	iorwf	coin_val_pos,w
; sauver en EEPROM :
	movwf	tmp_leaf1
	movfw	menu_coin_index
	addlw	EE_CHAN1val & 255
	call	S__EEPROM_write

cetaitunepiece
; tait-ce une pice ?
	btfss	thread_nri_accept,2
	; non alors retour : on vide l'cran, on remet le curseur  0 et on revient
	goto	LS2__clrlcd

; rcupre le n du nouveau canal
	movfw	NRI_chan
	addlw	-1
	movwf	menu_coin_index

; ACK pice
	bcf		thread_nri_accept,2

; remet le curseur du LCD  zro
	Macro_CALL_address	LS2__clrlcd, LS__MENU_coin_channel, 0
; reboucle
;	goto	LS__MENU_coin_channel



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Le menu principal propose 3 choix :
; bouton gauche : config manuelle
; bouton centre : suivant
; bouton droite : config auto
; reboucle tant que pas bouton centre.

LS__MENU__coin_value
; changer le nom de cette fonction quand elle sera termine

; comme on reboucle juste sur LS__MENU__coin_value,
; on remet le curseur  0
	clrf	tmp_leaf1
	Macro_CALL	LS1__set_DDRAM_address_linear, 0

; affiche le message
	LOAD_STRING_PTR	string_menu_config_coin
	Macro_CALL	L1S2__display_string, 1

; place le curseur devant le "OK"
	movlw	9
	movwf	tmp_leaf1
	Macro_CALL	LS1__set_DDRAM_address_linear, 1

; attendre que les 3 boutons soient relachs ( 1) puis appuys
	Macro_CALL	L__MENU__wait_kbd1, 1

	Macro_CALL	LS2__clrlcd, 1 ; utile pour plus tard

; est-ce le bouton droit ?
	btfsc	KBD_Right
	goto	MENU__coin_auto

	; affiche le message "insert coin / OK"
		LOAD_STRING_PTR	string_menu_auto
		Macro_CALL	L1S2__display_string, 0

;	; modifie le masque d'activation NRI : active tout
;		bsf STATUS, RP0	; (bank1)
;			movlw	0x3FF
;			iorwf	Port_NRI_DATA	; TRISA
;		bcf STATUS, RP0	; (bank0)

	; dbloque thread_nri et accepte les pices
		bsf		thread_nri_accept,3 ; dsactive la fentre d'acceptation du thread NRI
		bsf		thread_nri_accept,0 ; active l'attente d'impulsion
		movlw	thread_nri_accept
		Macro_WAIT	THREAD_WAIT_BIT1, 1, 0 ; attend que le thread soit rveill

	; initialise le canal  un numro interdit pour empcher l'criture de paramtres erronns
		movlw	8
		movwf	menu_coin_index

	; saute au milieur de la fonction de rglage du prix, l o a va
	; attendre que les 3 boutons soient relachs ( 1) puis appuys
		Macro_CALL	L__MENU__coin_kbd1, 0

	; dsactiver NRI et refuser les pices
		bcf		thread_nri_accept,3 ; remettre la fentre en place
		bcf		thread_nri_accept,0
		movlw	thread_nri_accept
		Macro_WAIT	THREAD_WAIT_BIT0, 1, 0
	; retourne au menu central
		goto	LS__MENU__coin_value


MENU__coin_auto

; est-ce le bouton gauche ?
	btfsc	KBD_Left
	goto	MENU__coin_manual
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sous-menu manuel (itratif)
; on boucle pour chacun des 6 canaux
		clrf	menu_coin_index  ; menu_coin_index est l'index du canal dans l'EEPROM
MENU__coin_chan_loop
			Macro_CALL	LS__MENU_coin_channel, 0
			; incrmente, et reboucle si < 7
			incf	menu_coin_index,f
			movlw	6
			xorwf	menu_coin_index,w
		btfss	STATUS,Z
		goto	MENU__coin_chan_loop
		goto	LS__MENU__coin_value ; retour
MENU__coin_manual


; Si c'est le bouton du milieu alors on sort de la boucle
	btfsc	KBD_Middle
	goto	LS__MENU__coin_value ; reboucle si glitch

;;;;;;;;;;;; fin de la page du menu

; Pour ractiver le masque NRI correctement,
; il faut rinitialiser le thread NRI


