; menu\menu_functions.asm
; version du 2 mai 2008 : ajout de l'autorepeat

; fonctions utilises/partages par les pages du menu et par les threads

; attendre que les 3 boutons soient relachs ( 1)
L__MENU__wait_kbd1

loop__wait_kbd1
	; si autorepeat=0 (cas normal) alors on continue
	movfw	autorepeat
	btfsc	STATUS,Z
	goto	no_autorepeat

	; sinon, le compteur est en marche : dcrmenter
		decfsz	autorepeat,f
		goto	no_autorepeat ; pas expir alors on continue  attendre

			; sinon compteur expir : rinitialise puis saute  la fin
			movlw	AUTOREPEAT_PUSH
			movwf	autorepeat
			goto	macro_return_functions

no_autorepeat
	movlw	10
	Macro_DELAY	0
	movfw	Port_kbd
	andlw	(1<<Bit_kbd_Left) | (1<<Bit_kbd_Middle) | (1<<Bit_kbd_Right)
	xorlw	(1<<Bit_kbd_Left) | (1<<Bit_kbd_Middle) | (1<<Bit_kbd_Right)
	btfss	STATUS,Z
	goto	loop__wait_kbd1

; bouton relch : on initialise la variable/flag
	movlw	AUTOREPEAT_TRIG
	movwf	autorepeat

; attendre qu'un des boutons soit appuy
MENU__wait_kbd2
	movlw	10
	Macro_DELAY 0
	movfw	Port_kbd
	andlw	(1<<Bit_kbd_Left) | (1<<Bit_kbd_Middle) | (1<<Bit_kbd_Right)
	xorlw	(1<<Bit_kbd_Left) | (1<<Bit_kbd_Middle) | (1<<Bit_kbd_Right)
	btfsc	STATUS,Z
	goto	MENU__wait_kbd2
macro_return_functions
	Macro_RETURN


; utilis par L3__thread_init_start et L2S3__MENU__change_currency
; calcule currency_sign en fonction de currency_index
; puis (ventuellement) charge la fonte correspondante
; en mettant  jour currency_sign
L1S1__lookup_currency_sign
	movfw	currency_index
	addlw	currency_list & 255
	movwf	string_low
	movlw	currency_list >> 8
;	movwf	string_low
	call	call_char_2
	movwf	currency_sign

; attention  restaurer PCLATH !!! voir le goto  la fin.

; charge la fonte du signe
	; si le signe >=16, alors c'est un ASCII
	andlw	0xF0 ; masque les MSB
	btfss	STATUS,Z
	goto	macro_return_functions


	; charger la fonte ici :
	clrf	tmp_leaf1 ; fonte n0
	clrf	tmp_leaf2 ; charge 1 fonte
	; calcule le pointeur vers la fonte : dcalage par 3 bits dans W pour viter un tmp_leaf
	swapf	currency_sign,f
	rrf		currency_sign,w ; W = signe<<3
	andlw	b'00111000' ; garde juste 3 bits,  cause de l'alias 0 vers 8  l'affichage
      ; (-> display_string considre le caractre 0 comme la fin de la chaine)
	clrf	currency_sign    ; le code ASCII "signe" est 0
     ; (le mettre  8 ? seulement si utilis avec display_string)
	addlw	font_debut & 255
	movwf	string_low
	movlw	font_debut >>8 ; ajoute l'adresse du dbut de la liste
;	btfsc	STATUS,C  ; retenue (non gre pour conomiser du code)
;	addlw	1
	movwf	string_high

	movlw	L1S2__load_font>>8
	movwf	PCLATH
	goto	L1S2__load_font
	; fold !


; Affiche un prix dont la valeur est dans cmp_LSB/MID/MSB
; * les variables tmp_XXX sont dtruites
; * affiche aussi la chaine de caractre dont le pointeur est
;       dj charg dans string_low/string_high
L1_DisplayPrice_ext
; vide l'cran
	Macro_CALL	LS2__clrlcd, 0
; affiche le message  gauche
	Macro_CALL	L1S2__display_string, 1
; fonction "normale" sans la prparation
L1_DisplayPrice
; place le curseur au dbut du nombre
	movlw	9
; ajuster les indices si pas de signe (en position linaire 16)
	btfss	currency_shift,4
	goto	coin_no_space_init
		incf	coin_val_pos,f  ; ajuste aussi l'exposant
		addlw	1
coin_no_space_init
	movwf	tmp_leaf1
	Macro_CALL	LS1__set_DDRAM_address_linear, 0

; affichage de la valeur du prix :
; conversion par soustractions successives (calqu sur LCD.asm:LS2__divide_int)
; en passant par une variable temporaire cmp_LSB/MID/MSB
; (a vite de se trimbaler 3 donnes pour le calcul quand 2 suffisent)
	clrf	leading0 ; n'affiche pas encore de 0

	movlw	const_100000MSB ; la base de dpart est le dernier digit
	movwf	base_index ; ATTENTION : la soustraction commence par le MSByte

; boucle 6 fois
	movlw	6
	movwf	char_cpt
init_loop_nb_coin

; calcul d'1 digit
		clrf	coin_val_digit
		Macro_SaveFSR_address tmp_leaf1 ; sauve FSR car on va en avoir besoin

loop_cmp_digit
		; compare la base courante  cmp
		movfw	base_index
		movwf	FSR

		; Soustrait la base courante  cmp_XXX
		; et met le rsultat dans tmp_XXX
		sub24Irr	cmp_LSB, tmp_LSB

		; si cmp > base alors valider la soustraction
		btfsc	tmp_MSB,7
		goto	digit_superieur_ou_egal	; sinon, passer au digit suivant

			incf	coin_val_digit,f	; incrmente le digit courant
			COPY24	tmp_LSB,cmp_LSB		; recopie le rsultat dans la source

			goto	loop_cmp_digit

digit_superieur_ou_egal
		Macro_RestoreFSR_address tmp_leaf1
; "dcrmente" la base
		movlw	3
		subwf	base_index,f

;;;; fin de la conversion BCD

	; Si le digit est  0, dcider si on met un espace ou non
		movfw	coin_val_digit
		btfss	STATUS,Z
		goto	display_coin_digit_init ; goto si char_cpt == coin_val_pos

	; afficher un 0 devant le signe pour plus de lisibilit
			movfw	cursor_index
			addlw	1
			xorwf	currency_shift,w
			btfsc	STATUS,Z
			goto	display_coin_digit_init
			movlw	0 ; restaure W  l'tat connu prcdent

			; affiche un espace si pas encore de chiffres non nuls
				btfss	leading0,0
					movlw	' '-'0'
				goto	write_tmp_leaf1_init

	; else : force l'affichage des prochains zros
display_coin_digit_init
			bsf		leading0,0 ; 
write_tmp_leaf1_init
		addlw	'0'
		movwf	tmp_leaf1
		Macro_CALL	LS2__LCD_display_char, 0

	; SI la position courante == tmp_currency_shift
		movfw	cursor_index
		xorwf	currency_shift,w
		btfss	STATUS,Z
		goto	init_coin_fin_loop

	; ALORS afficher le "signe"
			bsf		leading0,0 ; afficher les prochains zros
			movfw	currency_sign
			movwf	tmp_leaf1
			Macro_CALL	LS2__LCD_display_char, 1
init_coin_fin_loop

	; arrte la boucle ?
	decfsz	char_cpt,f
	goto	init_loop_nb_coin

	goto	macro_return_functions
