; mtk/dispatch.asm
; c'est la "boucle infinie" du programme.

;------------ Le dispatcheur ------------

MTK__start_dispatch
	; initialisations ?

MTK__dispatch

; nouvelle version (changer le T0IF par autre chose plus tard)
	bcf		wait_flags,T0IF ; effacement spculatif
	btfss	INTCON,T0IF	; teste le flag d'expiration
	goto	MTK__no_T0IF
	bcf		INTCON,T0IF	; efface le bit SI il est mis
	bsf		wait_flags,T0IF
MTK__no_T0IF

	; pour commencer  balayer la liste des contextes,
	; current_context_buffer = last_context_buffer
	movfw	last_context_buffer
	movwf	current_context_buffer

	; si current_context_buffer == 0, alors recommencer au dbut de la liste
	; (le test est effectu ici pour le cas o la boucle est vide)
MTK__loop_scan_dispatch
	btfsc	STATUS, Z
	goto	MTK__dispatch

	; current_context_buffer[OffsetState]
	movwf	FSR

	; prpare le saut en spcifiant PCLATH
	if ((MTK__start_state_function_table >> 8)==0)
		clrf	PCLATH
	else
		movlw	MTK__start_state_function_table >> 8
		movwf	PCLATH
	endif

	movfw	INDF		; lit l'tat
	movwf	MTK_leaf1	; et le sauve pour plus loin

; table de fonctions, en fonction du status du thread
	andlw	7; garde uniquement 8 codes
	addwf	PCL,f
MTK__start_state_function_table
	goto	MTK__continue_scan_dispatch	; #define	THREAD_ASLEEP		0 (ne fait rien)
	goto	MTK__jump_to_thread			; #define	THREAD_RUNNING		1
	goto	MTK__decrement_state			; #define	THREAD_WAIT_MS		2
	goto	MTK__continue_scan_dispatch	;	forbidden_state			; #define	THREAD_WAIT_SIG		3 ; inutile pour l'instant
	goto	MTK__dispatch_test			; #define	THREAD_WAIT_BIT0	4
	goto	MTK__dispatch_test			; #define	THREAD_WAIT_BIT1	5
	goto	MTK__dispatch_test			; #define	THREAD_WAIT_BYTE0	6
	goto	MTK__dispatch_test			; #define	THREAD_WAIT_BYTENZ	7
	if (($ >> 8) != ((MTK__start_state_function_table - 2) >> 8))
		error "MTK:table des fonctions trop prs d'une frontire 8 bits"
	endif

; fold ?

MTK__decrement_state
	; si la variable ne doit pas tre dcrmente, on passe directement  la suite
	btfss	wait_flags,T0IF
	goto	MTK__continue_scan_dispatch

	; dcrmentation effective :
	incf	FSR,f ; pointe sur OffsetVal
	decfsz	INDF, f
	goto	MTK__continue_scan_dispatch

	; OK : on change l'tat du thread et on saute dedans !
	decf	FSR,f ; repointe vers OffsetState
	goto	MTK__rerun2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

exp2table	; convertit l'tat (dans W) en masque
	swapf	MTK_leaf1,w
exp2table_noswap ; utile pour l'application mais ATTENTION  PCLATH !
	andlw	7
	addwf	PCL,f
	dt 1, 2, 4, 8, 16, 32, 64, 128
	if (($ >> 8) != ((exp2table_noswap - 2) >> 8))
		error "MTK:exp2table traverse une frontire 8 bits"
	endif

MTK__dispatch_test ; version on-ne-peut-plus-compacte mais pas forcment la plus rapide
	incf	FSR,f	; pointe sur val
	movfw	INDF	; pointeur dans W
	movwf	FSR		; la donne  tester est maintenant dans INDF

	movfw	INDF	; inverse la condition
	btfss	MTK_leaf1,0
	xorlw	-1

	btfsc	MTK_leaf1,1 ; saute le test de bits
	goto	MTK__test_byte
		movwf	MTK_leaf2
		call	exp2table
		andwf	MTK_leaf2,w
MTK__test_byte
	btfsc	STATUS, Z	; si Z=0, alors excuter le thread.
	goto	MTK__continue_scan_dispatch

MTK__rerun ; on change l'tat du thread et on saute dedans
	movfw	current_context_buffer ; repointe vers le dbut du bloc de contexte
	movwf	FSR
MTK__rerun2 ; venant de decrement_state
	movlw	THREAD_RUNNING
	movwf	INDF

; ce code "retourne" dans le contexte courant (FSR=dbut du contexte courant)
MTK__jump_to_thread
	movlw	OffsetSP	; FSR pointe sur le dbut du buffer, ne pas oublier
	; de l'y remettre si d'autres champs sont accds par des routines de test
	addwf	FSR,f	; pointe vers le pointeur de pile

	movfw	INDF	; restaure la pile
#ifdef	STACK_HIGH
	movwf	MTK_leaf1
		incf	FSR,f	; pointe sur OffsetSTATUS
		movfw	INDF
		movwf	STATUS
	movfw	MTK_leaf1
#endif
	movwf	FSR
	
; dpile PCLATH :
;	decf	FSR, f : pas besoin
	movfw	INDF
	movwf	PCLATH
; dpile PCL et branche :
	decf	FSR, f
	movfw	INDF
	movwf	PCL		; saut de l'ange...


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; retour :
; W : 
; MTK_leaf1 = PCL de retour, puis STATUS
; MTK_leaf2 = dlai pour MTK_DELAY, adresse pour MTK_WAIT
; MTK_leaf3 = FSR temporaire
; MTK_leaf4 = nouvel tat du thread

MTK__prolog ; utilis par un peu tout le monde pour commencer  sauver le contexte
	movwf	INDF
	incf	FSR, f
	movfw	MTK_leaf1
	movwf	INDF

	; sauve le pointeur de pile
	movfw	FSR
	movwf	MTK_leaf3 ; FSR

; sauve STATUS (1/2)
#ifdef	STACK_HIGH
	movfw	STATUS
	movwf	MTK_leaf1
	clrf	STATUS
#endif
	; pointe sur le buffer de contexte
	movfw	current_context_buffer
	return


; adapt de MTK_DELAY
; la macro d'appel est plus longue car on change aussi l'tat
; - la valeur  donner au thread est dans MTK_leaf2
; - le nouvel tat  donner au thread est dans MTK_leaf4
MTK_CHANGE_STATE
	call	MTK__prolog
	movwf	FSR	; pointe sur l'tat dans le buffer de contexte

	; change l'tat du thread
	movfw	MTK_leaf4
	movwf	INDF
	incf	FSR,f

	; met  jour la valeur
	movfw	MTK_leaf2
	movwf	INDF
	incf	FSR,f ; saute NEXT
	incf	FSR,f ;	pointe sur OffsetSP
	
	goto	MTK__fold_yield


; "pseudo-fonction" utilise par un thread pour attendre sans bloquer tout le monde
; - le dlai est donn dans MTK_leaf2
; - c'est copi-coll-adapt de MTK_YIELD
MTK_DELAY
	call	MTK__prolog
	movwf	FSR	; pointe sur l'tat dans le buffer de contexte

	; change l'tat du thread
	movlw	THREAD_WAIT_MS
	movwf	INDF
	incf	FSR,f

	; met  jour la valeur
	movfw	MTK_leaf2
	movwf	INDF
	incf	FSR,f ; saute NEXT
	incf	FSR,f ;	pointe sur OffsetSP
	
	goto	MTK__fold_yield

; "pseudo-fonction" utilise par un thread pour redonner la main au dispatcheur :
MTK_YIELD
	call	MTK__prolog
	addlw	OffsetSP
	movwf	FSR
MTK__fold_yield
	movfw	MTK_leaf3 ; FSR
	movwf	INDF

; sauve STATUS (2/2)
#ifdef	STACK_HIGH
	incf	FSR,f
	movfw	MTK_leaf1
	movwf	INDF
#endif

; retour en douceur dans le dispatcheur...

MTK__continue_scan_dispatch
	; passer au contexte suivant :
	; contexte = contexte[OffsetNext]
	movfw	current_context_buffer
	addlw	OffsetNext
	movwf	FSR
	movfw	INDF
	movwf	current_context_buffer
	goto	MTK__loop_scan_dispatch

;	#ifdef	STACK_OVERFLOW_DETECTION
;error_stack_overflow
;	#endif
;
;forbidden_state
;; dsactive tout
;	bcf		INTCON,GIE	; dsactive les IRQ
;	MACRO_NRI_INHIBIT	; inhibition NRI
;	bcf	relais			; relais dsactiv
;;	affiche "KO" :
;	call	Reset_LCD
;	movlw	'K'
;	call	LCD_send_data_init
;	movlw	'O'
;	call	LCD_send_data_init
;endless_forbidden_state
;	goto	endless_forbidden_state
;
;message_state	dt "state", 0
;message_stack	dt "stack", 0
;message_error	dt " error", 0
;
;
