; mtk/init_threads.asm
; de 26  42 instructions selon le mode
; 38 en comptant la fonction de lookup, avec PROTECT_STACK et sans STACK_HIGH

;------------ Initialisation des threads ------------
; c'est une boucle qui va lire dans le tableau accd par la fonction get_next_value
; cette boucle se termine par la continuation de get_next_value dans le dispatcheur.

MTK__init_all_threads
	clrf	last_context_buffer	; initialise la fin de la liste chaine
	clrf	tmp_leaf2	; initialise le compteur de constantes
MTK__init_next_thread
	call	MTK__get_next_value	;	movlw	thread_base
	; ce call saute directement  mtk_start_dispatch quand la liste est termine,
	; sans dpiler l'adresse de retour, dont on se fout d'ailleurs (la pile hw
	; du PIC s'en accomode bien).
	movwf	FSR
	movwf	tmp_leaf1 ; sauve aussi pour un peu plus loin

	; index = 0 => remplit le champ OffsetState
	call	MTK__get_next_value
	movwf	INDF
	incf	FSR,f

	; index = 1 => remplit VAL
	call	MTK__get_next_value
	movwf	INDF
	incf	FSR,f

	; index = 2 => next
	; chaine le bloc  la liste
	movfw	last_context_buffer
	movwf	INDF
	movfw	tmp_leaf1
	movwf	last_context_buffer
	incf	FSR,f

	#ifdef	STACK_HIGH
		call	MTK__get_next_value	; Stack Pointer (FSR)
		movwf	tmp_leaf1 ; pour remplir la pile plus tard
		addlw	1	; princrmente l'adresse
		movwf	INDF
		incf	FSR,f

		call	MTK__get_next_value	; STATUS
		movwf	INDF
		movwf	STATUS	; pointe sur la pile
		movfw	tmp_leaf1
		movwf	FSR
		
		; remplit la pile
		call	MTK__get_next_value ;	StartIP&255
		movwf	INDF
		incf	FSR,f
		call	MTK__get_next_value ;	StartIP>>8
		movwf	INDF

	#else
		; index = 3 => remplit le champ SP (automatiquement)
;		movfw	tmp_leaf1 ; dj charg par les instructions prcdentes
		addlw	OffsetStack+1 ; la premire excution est presque comme Macro_RETURN, avec un incf/decf en moins
		movwf	INDF
		incf	FSR,f

		; index 4 et 5 : remplit la pile
		call	MTK__get_next_value ;	StartIP&255
		movwf	INDF
		incf	FSR,f
		call	MTK__get_next_value ;	StartIP>>8
		movwf	INDF

	#endif

	#ifdef PROTECT_STACK		; remplit la pile de zros
		call	MTK__get_next_value ;	stack depth
		movwf	tmp_leaf1
		movlw	STACK_PATTERN
MTK__loop_clear_stack
		incf	FSR,f
		movwf	INDF
		incf	FSR,f
		movwf	INDF
		decfsz	tmp_leaf1,f
		goto	MTK__loop_clear_stack
	#endif

	#ifdef	STACK_HIGH
		bcf		STATUS, IRP	; retourne en banques0/1
	#endif

	; reboucle
	goto	MTK__init_next_thread
