; mtk/mtk.inc : quelques paramtres de configuration,
; dpendants du modle de PIC et de l'application.
; C'est le seul fichier du MTK qui soit modifiable sans casser le MTK.

; variables "leaf" pour le MTK, accessible dans toutes les banques :
MTK_leaf1	EQU	0x78
MTK_leaf2	EQU	0x79
MTK_leaf3	EQU	0x7A
MTK_leaf4	EQU	0x7B

#define PROTECT_STACK ;  dfinir pour ajouter du code de protection
; (qui n'est pas encore super au point) et pour remplir la pile avec STACK_PATTERN

#define STACK_PATTERN 0xBB
; valeur d'initialisation des octets dans la pile soft si PROTECT_STACK est dfini

#define DEBUG_SAFE ; si l'ICD2 est utilis en mode debug,
; il rduit la mmoire disponible. A laisser par dfaut,
; pour le dveloppement. Valeurs  changer aussi selon le CPU !

;#define STACK_HIGH
; Utile si 4 banques de mmoire data disponibles, comme sur 16F877/876.
; Enlever cette dfinition pour le 16F873/874 par exemple,
; ou bien si la vitesse est importante et il n'y a pas besoin de
; beaucoup de mmoire.

; valeurs utilises sur PIC16F877
#define  LAST_CONTEXT_ADDRESS 0xF0
#define FIRST_CONTEXT_ADDRESS 0xA0
; La taille utilise par chaque contexte dpend du mode
; (si STACK_HIGH est dfini ou pas) et de la profondeur de la pile.

#ifdef	STACK_HIGH
	#ifdef	DEBUG_SAFE
		#define	LAST_STACK_ADDRESS	0x1E5 ; prserve l'espace rserv ICD2 (OK sur 877 et 887)
	#else
		#define	LAST_STACK_ADDRESS	0x1F0 ; fin de la banque 3
	#endif
	#define	FIRST_STACK_ADDRESS 0x190
#endif


; dfinitions de la machinerie interne du MTK :
    #include "mtk\dispatch.inc"
