; threads\thread_init.asm
; version du 30 avril 2008

	#include "menu\menu_contrast.asm"
	; exception car on doit pouvoir l'appeler au dmarrage
	; le reste du code des pages est insr/fold

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Il y a plusieurs boucles d'attente dans l'applicatif,
; chacune devant pouvoir donner accs  des fonctions identiques.
;
; Cette fonction est donc appele quand la cl est valide
; et distingue entre l'accs au menu et l'accs "free".
; Le menu permet de changer les paramtres internes
; et de dbloquer des situations.
;
; Attention :  la fin, revalider l'activation du relais et du NRI !
; --> c'est fait en sautant directement (fold)  Display_current_credit

L_cle_menu
	MACRO_BACKLIGHT_ON
	bcf		thread_nri_accept,0
loop_wait_ACK_NRI
		Macro_CALL	LS2__clrlcd, 0
		; l'accs au LCD entraine un dlai donc un yield
		; suffisant pour que l'autre thread rponde.
	btfsc	thread_nri_accept,1
	goto	loop_wait_ACK_NRI

	; test du bouton :
	; saute  la boucle "free" si le bouton gauche/- n'est pas appuy
	btfsc	KBD_Left
	goto	thread_init_free

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; menu de configuration
	MACRO_RELAIS_OUVRE ; pas de copie dans le menu

;  configure le curseur :
	movlw	LCD_C_CursorOn | LCD_B_CursorBlink
	movwf	tmp_leaf1
	Macro_CALL	LS2__change_cursor, 0

; Toutes les fonctions foldent dans les suivantes (sauf le changement de contraste pour conomiser de la place).
loop_menu_init
	Macro_CALL	L2__MENU__change_contrast, 0
	btfsc	Port_kbd, Bit_kbd_Lock
	goto	macro_return_init

	#include "menu\menu_clear_credit.asm"
	btfsc	Port_kbd, Bit_kbd_Lock
	goto	macro_return_init

    #include "menu\menu_currency.asm" ; change le curseur
	btfsc	Port_kbd, Bit_kbd_Lock
	goto	macro_return_init

	#include "menu\menu_position.asm"
	btfsc	Port_kbd, Bit_kbd_Lock
	goto	macro_return_init

	#include "menu\menu_coin_value.asm"
	btfsc	Port_kbd, Bit_kbd_Lock
	goto	macro_return_init

	#include "menu\menu_page_price.asm"
	btfss	Port_kbd, Bit_kbd_Lock
	goto	loop_menu_init

	; ajouter les autre pages du menu ici.

macro_return_init
	clrf	tmp_leaf1 ; teint le curseur
	Macro_CALL_address	LS2__change_cursor, Display_current_credit,0
;	goto	Display_current_credit

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; boucle d'attente "free" :
thread_init_free
	MACRO_RELAIS_FERME
; affiche le message indiquant le "mode free"
	LOAD_STRING_PTR	string_free
	Macro_CALL	L1S2__display_string, 0

	; attend que la cl soit enleve :
	movlw	Port_kbd
	Macro_WAIT	THREAD_WAIT_BIT1, Bit_kbd_Lock, 0
	goto	Display_current_credit


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; LE THREAD PRINCIPAL ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

current_context_base set thread_init_base ; rassigne current_context_base pour des macros

; Dbut de l'applicatif :
L3__thread_init_start

;;;;; Init du LCD et des fontes

; initialise les constantes de calcul
; (je sais, c'est compltement pourri ! mais j'ai pas le choix)
	SET_CONSTANTE24B  const_1LSB, 1
	SET_CONSTANTE24B  const_10LSB, 10
	SET_CONSTANTE24B  const_100LSB, 100
	SET_CONSTANTE24B  const_1000LSB, 1000
	SET_CONSTANTE24B  const_10000LSB, 10000
	SET_CONSTANTE24B  const_100000LSB, 100000 ; faire une boucle ?

; lire le solde dans l'EEPROM
	READEEPROM EE_solde_LSB, sum_LSB
	READEEPROM EE_solde_MID, sum_MID
	READEEPROM EE_solde_MSB, sum_MSB
; lire le prix d'une page
	READEEPROM EE_page_price_A4BW_LSB, page_price_LSB
	READEEPROM EE_page_price_A4BW_MID, page_price_MID
	READEEPROM EE_page_price_A4BW_MSB, page_price_MSB
; position du symbole de la monnaie
	READEEPROM EE_currency_shift, currency_shift
; chargement des paramtres de langue de l'EEPROM
	READEEPROM EE_currency_index, currency_index  ; remplacer toutes ces lectures par une boucle ?

	call	S3__Reset_LCD ; seule fois o cette fonction est appele dans un thread.
	; attention : si c'est plac avant le code de lookup EEPROM,
	; a affiche pas la premire moiti de l'cran (raison inconnue)

; consulte la table pour obtenir le signe alphanumrique
	Macro_CALL	L1S1__lookup_currency_sign, 0
	clrf	tmp_leaf1
	Macro_CALL	LS1__set_DDRAM_address_linear, 1

; dtection de la condition du changement de contraste
	movfw	Port_kbd
	andlw	(1<<Bit_kbd_Left) | (1<<Bit_kbd_Middle) | (1<<Bit_kbd_Right)
	xorlw	(1<<Bit_kbd_Middle)
	btfss	STATUS,Z
	goto	init_finished
		Macro_CALL	L2__MENU__change_contrast, 1
		; entre dans le menu du contraste qui termine en effaant l'cran.
init_finished

;;;;;;;;;;;;;;; affichage des messages de dmarrage ;;;;;;;;;;;;;;;
; premier message
	LOAD_STRING_PTR	string_startup
	Macro_CALL	L1S2__display_string, 0
; attendre 1s
	movlw	10
	movwf	thread_init_scroll
loop_message_startup
		movlw	112 ; 100ms
		Macro_DELAY	0
	decfsz	thread_init_scroll,f
	goto	loop_message_startup

	Macro_CALL	LS2__clrlcd, 1
; affichage du 2 message (pas besoin de changer le pointeur)
	Macro_CALL	L1S2__display_string, 1
; attendre 1s
	movlw	10
	movwf	thread_init_scroll
loop_message_startup2
		movlw	112 ; 100ms
		Macro_DELAY	0
	decfsz	thread_init_scroll,f
	goto	loop_message_startup2


; au dmarrage, le solde est peut-tre non nul,
; donc activer les sorties en consquence !
	goto	Display_current_credit



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; boucle d'affichage des pices
;
; Ici on entre dans une boucle qui affiche constamment le prix
; et on attend des pices et des copies.


; on arrive ici quand une pice est insre.
thread_init_loop_coin
; lecture du canal et dcodage de la valeur
	movfw	NRI_chan
	addlw	(EE_CHAN1val-1) & 255
	call	S__EEPROM_READ
	movwf	chan_value

; scinde la valeur en exposant et mantisse
	; exposant
	andlw	7 ; l'index est infrieur  6
	movwf	coin_exponent
	addlw	1 ; off-by-one dans la boucle d'affichage
	movwf	coin_val_pos
	; mantisse :
	swapf	chan_value,w
	andlw	7 ; la valeur de la pice est infrieure ou gale  5
	movwf	coin_val_digit

	CALL_MTK_YIELD 0

; additionne la valeur au solde courant
	; d'abord, dterminer l'adresse de l'exposant  additionner
	Macro_SaveFSR_address tmp_leaf1 ; sauve FSR
	movfw	coin_exponent 
	addwf	coin_exponent, w ; multiplier l'indice par 3
	addwf	coin_exponent, w
	; puis ajouter l'adresse de dpart du tableau
	addlw	const_1LSB
	movwf	FSR ; c'est maintenant notre pointeur vers le digit  additionner

	; maintenant : boucler coin_val_digit fois pour additionner cet exposant (soit 5x max)
loop_add24_coin
		add24Ir	sum_LSB ; MACRO
		decf	FSR,f ; retourne en arrire pour le tour suivant
		decf	FSR,f

	decfsz	coin_val_digit,f
	goto	loop_add24_coin
	Macro_RestoreFSR_address tmp_leaf1 ; restaure FSR
; Ici, le solde est mis  jour.

; une fois la valeur calcule, on ACK la pice et on libre le thread NRI
	bcf		thread_nri_accept,2
; et on recommence 

;;;;;;;;;;;;;;; FIN ACCUMULATION PIECES ;;;;;;;;;;;;;;;

Display_current_credit

; Dtermine si le relais doit tre activ :
	; soustrait la valeur de la page
	sub24rrr	sum_LSB, tmp_LSB, page_price_LSB
	; Si le rsultat <0, alors on ouvre le relais
	btfsc	tmp_MSB,7
		MACRO_RELAIS_OUVRE ; la macro doit avoir 1 seule instruction...
	btfss	tmp_MSB,7	
		MACRO_RELAIS_FERME

; dtermine si le NRI doit tre activ :
	; soustrait la valeur maximum admissible
	sub24irr	sum_LSB, tmp_LSB, 900000
	btfsc	tmp_MSB,7
		bsf		thread_nri_accept,0
	btfss	tmp_MSB,7	
		bcf		thread_nri_accept,0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; dtecte si le solde est nul
	movfw	sum_LSB
	iorwf	sum_MID,w
	iorwf	sum_MSB,w
	btfsc	STATUS,Z
	goto	start_scrolling

; AFFICHAGE (tout plein de trucs dans 1 seule fonction...)

; message "solde"/"credit"
	LOAD_STRING_PTR	string_solde
; affiche le prix
	COPY24	sum_LSB,cmp_LSB
	Macro_CALL	L1_DisplayPrice_ext, 0

; boucle d'attente normale, attend aussi la photocopieuse

loop_wait_coin_2
		movlw	11 ; 10ms
		Macro_DELAY	0

		; cl menu ?
		btfsc	KBD_Lock
		goto	pas_cle_menu2
			Macro_CALL_address	L_cle_menu, Display_current_credit, 0
			; on retourne  Display_current_credit  cause du cas
            ; o le solde ou les paramtres de l'affichage ont t changs
pas_cle_menu2


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; <JUSTE POUR LE DEBUG> :

;  soustraction 
		btfsc	KBD_Right
		goto	no_button_copie

		; attendre que le bouton soit relch
loop_wait_button_copy
				movlw	10
				Macro_DELAY 0
				btfss	KBD_Right
				goto	loop_wait_button_copy

; en fait la soustraction ne devrait JAMAIS retourner de
; ngatif, car si c'est le cas, alors l'algo a autoris
; pralablement la photocopieuse  faire des copies
; qu'elle n'aurait pas d faire.

			; mais on teste quand mme car le bouton peut tre
			; appuy mme si la copie n'est pas autorise.
			btfss	relais
			goto	Display_current_credit

			; soustrait la valeur de la page
			sub24rr	sum_LSB, page_price_LSB
			goto	Display_current_credit

			
no_button_copie
; </JUSTE POUR LE DEBUG>
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; photocopieuse ici
		; obtenir le prix de la page

		; soustraction

		; goto	Display_current_credit


		btfsc	thread_nri_accept,2
		goto	thread_init_loop_coin

; vrifier s'il faut sauver en EEPROM le solde courant

	goto	loop_wait_coin_2



;;;;;;;;;;;;;;;;;;; boucle vide avec scroll ;;;;;;;;;;;;;;;;;;;

start_scrolling
; dbloque l'autre thread et accepte les pices
	bsf		thread_nri_accept,0
; empche les photocopies
;	MACRO_RELAIS_OUVRE

	Macro_CALL	LS2__clrlcd, 0 ; fournit qqs yield, le thread NRI a le temps de rpondre

start_scrolling2
	; dcompteur pour teindre le LCD (compte le nb de fois que le message a dfil)
	movlw	3
	movwf	thread_init_blackout

; vrifier si le sens de dfilement est invers (europen ou arabe)
	if scroll_left==1
		clrf	thread_init_scroll
	else
		movlw	scroll_string_length
	    movwf	thread_init_scroll
	endif

;;;;;; boucle de scrolling
thread_init_loop

; remet le curseur au dbut
	clrf	tmp_leaf1 ; index=0
	Macro_CALL	LS1__set_DDRAM_address_linear, 0

; affiche le message avec un offset
	movlw	scroll_string>>8
	movwf	string_high
	movlw	scroll_string & 255
	addwf	thread_init_scroll,w
	movwf	string_low
	Macro_CALL	L1S2__display_string, 1

	movlw	255
	movwf	thread_init_cpt1
loop_wait_scroll
		movlw	1
		Macro_DELAY 0

		; cl menu ?
		btfss	KBD_Lock
			goto	L_cle_menu

		; pice ?
		btfsc	thread_nri_accept,2
			goto	thread_init_loop_coin ; alors enregistrer la pice

	decfsz	thread_init_cpt1,f
	goto	loop_wait_scroll

	; dplace le pointeur de dbut en fonction de la langue

	if scroll_left==1
		incf	thread_init_scroll,w
		movwf	thread_init_scroll
		xorlw	scroll_string_length
		btfss	STATUS,Z
		goto	thread_init_loop
		clrf	thread_init_scroll
	else
		decfsz	thread_init_scroll,f
		goto	thread_init_loop
		movlw	scroll_string_length
	    movwf	thread_init_scroll
	endif

	; en cas de rebouclage du message, dcompter avant d'teindre l'cran
	decf	thread_init_blackout,f
	btfsc	STATUS,Z
	MACRO_BACKLIGHT_OFF ; excut toutes les 256 rotations mais c'est pas grave
	goto	thread_init_loop


