; threads\thread_nri.asm
; version 2008-02-28 : calcul diffrent des dures pour permettre la calibration par d'autres threads

current_context_base set thread_nri_base

thread_nri_start
	clrf	thread_nri_accept ;initialise l'tat du thread

; lecture des diffrents paramtres du NRI dans l'EEPROM :

; dure nominale de l'impulsion
	READEEPROM EE_NRI_pulse_length_nom, NRI_pulse_length_nom

; activation des canaux :
; une broche de PORTA force  0 inactive ledit canal 
	clrf	Port_NRI_DATA ; met le port data  0, l'inactivation est faite par TRISA
	READEEPROM EE_CHAN_EN, thread_nri_mask
	MACRO_activate_NRI_port ; met  jour TRISA (/!\ W contient la valeur)

; boucle globale
thread_nri_restart
	bcf	thread_nri_accept, 1 ; ACK fini d'attendre d'activation
	MACRO_NRI_INHIBIT

; boucle d'attente de l'activation du thread
	movlw	thread_nri_accept
	Macro_WAIT	THREAD_WAIT_BIT1, 0, 0
	bsf		thread_nri_accept,1 ; ACK d'attente de pice

thread_nri_wait_coin
	MACRO_NRI_ACCEPT

; attendre le dbut de l'impulsion
thread_nri_wait_pulse1
		btfss	thread_nri_accept,0;	; si demande d'arrt,
		goto	thread_nri_restart		; alors remettre  zro

		CALL_MTK_YIELD 0

; lecture du port NRI
		movfw	Port_NRI_DATA
		andwf	thread_nri_mask, w; 0x3F ; garde juste les canaux qui nous concernent
		xorwf	thread_nri_mask, w ;0x3F ; inverse les bits
					; attention : le calcul avec thread_nri_mask
					; est important pour ne garder que les bons canaux
					; car la lecture des canaux dsactivs retourne aussi 0
		; reboucler tant que le rsultat est  0 :
		btfsc	STATUS,Z
		goto	thread_nri_wait_pulse1

; OK,  ce niveau, une pice semble avoir t accepte par le NRI,
; on a le premier front de l'impulsion.
	movwf	NRI_data ; garde l'info dudit canal pour plus tard

; initialise le compteur de longueur d'impulsion
	clrf	thread_nri_pulse_length ; utilis en mode compteur

	MACRO_BACKLIGHT_OFF

; attente de la fin de l'impulsion
thread_nri_wait_pulse0

	; incrmente le compteur, mais sans reboucler :

	; incrmente le compteur de manire  mettre C  jour
		movlw	1
		addwf	thread_nri_pulse_length,w
	; Si C alors thread_nri_pulse_length==255 (max) donc ne pas crire le rsultat (0)
		btfss	STATUS,C
		movwf	thread_nri_pulse_length

; attendre 1ms
		movlw	1
		Macro_DELAY	0

; relecture du port NRI
		movfw	Port_NRI_DATA
		andwf	NRI_data,w	; masque avec le bit isol prcdemment
		btfsc	STATUS,Z ; reboucle si le canal est toujours  0
		goto	thread_nri_wait_pulse0

; impulsion accepte : on bloque le NRI tant que l'impulsion n'est pas accepte par l'autre thread
	MACRO_NRI_INHIBIT

; fin de l'impulsion "noire" sur le backlight du LCD
	MACRO_BACKLIGHT_ON

; vrifier que l'impulsion reste bien  0 pendant 50ms ? pas besoin, il semble.

; saute la fentre si le flag idoine est mis
	btfsc	thread_nri_accept,3
	goto	no_NRI_window

; vrification que l'impulsion est dans la "fentre" de dure
; en cas d'erreur, on attend une nouvelle impulsion en rebouclant sur thread_nri_wait_coin
;  une erreur spcifique est-elle dsirable ?

; teste si dure < nom-delta
	movfw	NRI_pulse_length_nom
	addlw	-NRI_PULSE_LENGTH_DELTA
	subwf	thread_nri_pulse_length,w
	btfss	STATUS,C
	goto	thread_nri_wait_coin
	
; on cherche si W>2*delta
	addlw	-(NRI_PULSE_LENGTH_DELTA*2)
	btfsc	STATUS,C
	goto	thread_nri_wait_coin


no_NRI_window
; dcodage de l'impulsion (logarithme par dcalage)
	clrf	NRI_chan	; attention au OffByOne !
nri_chan_log
	incf	NRI_chan,f ; on incrmente l'index tant que le masque NRI_data contient un bit  1
	rrf		NRI_data,f ; dcale le MSB dans C
	btfss	STATUS,C
	goto	nri_chan_log

; NRI_chan contient le n du canal  dcoder par l'autre thread.

; prvenir le thread principal
	bsf		thread_nri_accept,2
; attendre qu'il rponde (en remettant le bit  0)
	movlw	thread_nri_accept
	Macro_WAIT	THREAD_WAIT_BIT0, 2, 0 ; thread_nri_restart

; rebouclage
	btfsc	thread_nri_accept,0;	; si pas demande d'arrt,
	goto	thread_nri_wait_coin	; alors teindre le NRI et recommencer l'attente.
	goto	thread_nri_restart		; sinon, attendre 1 autre pice
